# Interface VulkanDebuggingType

All Known Implementing Classes:
  `VulkanLWJGLDebugging`, `VulkanLWJGLDebuggingNoOp`

public interface VulkanDebuggingType

Debugging operations that can use the functions exposed by extensions such as `VK_EXT_debug_utils` internally.

Many operations are silent no-ops if the relevant extensions are not present.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Interface
  Description
  `static final record`
  `VulkanDebuggingType.Color`
  A label color.
  `static interface`
  `VulkanDebuggingType.VulkanDebugRegionType`
  A debugging region in a command buffer.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default VulkanDebuggingType.VulkanDebugRegionType`
  `begin(VulkanCommandBufferType commandBuffer, String label)`
  Open a command buffer debug label region.
  `VulkanDebuggingType.VulkanDebugRegionType`
  `begin(VulkanCommandBufferType commandBuffer, String label, VulkanDebuggingType.Color color)`
  Open a command buffer debug label region.
  `static VulkanDebuggingType.Color`
  `black()`
  `void`
  `setObjectName(VulkanHandleType handle, String name)`
  Set the name of the given object.

- ## Method Details

  - ### black

    static VulkanDebuggingType.Color black()
    Returns:
      The opaque black color

  - ### setObjectName

    void setObjectName(VulkanHandleType handle, String name) throws VulkanException
    Set the name of the given object.
    Parameters:
      `handle` - The handle
      `name` - The name
    Throws:
      `VulkanException` - On errors

  - ### begin

    VulkanDebuggingType.VulkanDebugRegionType begin(VulkanCommandBufferType commandBuffer, String label, VulkanDebuggingType.Color color) throws VulkanException
    Open a command buffer debug label region.
    Parameters:
      `commandBuffer` - The command buffer
      `label` - The region label
      `color` - The region color
    Returns:
      The region
    Throws:
      `VulkanException` - On errors

  - ### begin

    default VulkanDebuggingType.VulkanDebugRegionType begin(VulkanCommandBufferType commandBuffer, String label) throws VulkanException
    Open a command buffer debug label region.
    Parameters:
      `commandBuffer` - The command buffer
      `label` - The region label
    Returns:
      The region
    Throws:
      `VulkanException` - On errors